SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

!Number methodsFor: '*EjerciciosPoo-Measure' stamp: 'JuanEdi 5/22/2013 21:07'!
amount
	^ self! !

!Number methodsFor: '*EjerciciosPoo-Measure' stamp: 'JuanEdi 5/22/2013 21:08'!
unit
	^ NullUnit instance! !

Object subclass: #Measure
	uses: TComparable
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Measure class
	uses: TComparable classTrait
	instanceVariableNames: ''!

!Measure class methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 16:30'!
canNotConvertMeasurementErrorMessage
	
	^ 'Can not convert measurement'.! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/22/2013 20:13'!
canNotConvertMeasurementException

	^ self error: self canNotConvertMeasurementErrorMessage.! !

!Measure class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 20:17'!
withAmount: anAmount measuredIn: aDistanceUnit 
	^ self new initializeWithAmount: anAmount andUnit:aDistanceUnit.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 16:46'!
* aNumber 
	^ Measure withAmount: self amount * aNumber measuredIn: self unit.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/22/2013 20:55'!
+ anotherMeasure
	|newAmount| 
	self validateUnitIsOfSameDomain: (anotherMeasure unit).
	
	newAmount := self amountInPatternUnit + anotherMeasure amountInPatternUnit.
	^ Measure withAmount: newAmount measuredIn: (self unit patternUnit)! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 16:48'!
- anotherMeasure
	^ self + anotherMeasure negated.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 16:48'!
/ aNumber 
	^ self * (1/aNumber).! !

!Measure methodsFor: 'comparing' stamp: 'FranciscoWesner 5/21/2013 16:48'!
< anotherMeasure
	^ self amountInPatternUnit < anotherMeasure amountInPatternUnit.! !

!Measure methodsFor: 'comparing' stamp: 'FranciscoWesner 5/21/2013 16:48'!
<= aComparable 
	"Answer whether the receiver is less than or equal to the argument."

	^ (self > aComparable) not! !

!Measure methodsFor: 'comparing' stamp: 'FranciscoWesner 5/21/2013 15:30'!
= anotherObject
	^ ((anotherObject isKindOf: Measure)
		and: [ self unit patternUnit = anotherObject unit patternUnit ])
		and: [ self amountInPatternUnit = anotherObject amountInPatternUnit ].! !

!Measure methodsFor: 'comparing' stamp: 'FranciscoWesner 5/21/2013 16:47'!
> aComparable 
	"Answer whether the receiver is greater than the argument."

	^ aComparable < self! !

!Measure methodsFor: 'comparing' stamp: 'FranciscoWesner 5/21/2013 16:47'!
>= aComparable 
	"Answer whether the receiver is greater than or equal to the argument."

	^ aComparable <= self! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 20:17'!
amount
	^ amount! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 21:26'!
amountInPatternUnit
	^ self unit convertAmountToPatternUnit: amount! !

!Measure methodsFor: 'comparing' stamp: ''!
between: min and: max 
	"Answer whether the receiver is less than or equal to the argument, max, 
	and greater than or equal to the argument, min."

	^self >= min and: [self <= max]! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/22/2013 20:54'!
convertTo: aUnit 
	|amountInPatternUnit amountInTargetUnit|
	
	self validateUnitIsOfSameDomain: aUnit.
	
	amountInPatternUnit := unit convertAmountToPatternUnit: amount.
	amountInTargetUnit := aUnit convertAmountFromPatternUnit: amountInPatternUnit.
	
	^ Measure withAmount: amountInTargetUnit measuredIn: aUnit.! !

!Measure methodsFor: 'comparing' stamp: 'JuanEdi 5/20/2013 21:27'!
hash 
	^ self amountInPatternUnit hash! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 16:06'!
initializeWithAmount: anAmount andUnit: aMessureUnit 
	amount := anAmount.
	unit := aMessureUnit.! !

!Measure methodsFor: 'comparing' stamp: ''!
max: aComparable 
	"Answer the receiver or the argument, whichever is greater."

	self > aComparable
		ifTrue: [^self]
		ifFalse: [^aComparable]! !

!Measure methodsFor: 'comparing' stamp: ''!
min: aComparable 
	"Answer the receiver or the argument, whichever is lesser."

	self < aComparable
		ifTrue: [^self]
		ifFalse: [^aComparable]! !

!Measure methodsFor: 'comparing' stamp: ''!
min: aMin max: aMax 

	^ (self min: aMin) max: aMax! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 16:48'!
negated
	^ Measure withAmount: (self amount) negated measuredIn: self unit. ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/22/2013 20:09'!
printString 
	^ amount printString , ' ' , unit printString asPluralBasedOn: amount.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 16:49'!
to: stopMeasure
	^ self to: stopMeasure by:  ( Measure withAmount: 1 measuredIn: self unit ) 
	! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 16:50'!
to: stopMeasure by: stepMeasure
	^ MeasureInterval from: self to: stopMeasure by: stepMeasure! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 20:17'!
unit
	^ unit! !

!Measure methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/22/2013 20:53'!
validateUnitIsOfSameDomain: aUnit
	(self unit patternUnit = aUnit patternUnit)
		ifFalse: [ ^ self class canNotConvertMeasurementException signal. ]! !

Object subclass: #MeasureUnit
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

MeasureUnit subclass: #DerivedUnit
	instanceVariableNames: 'patternUnit conversionToPatternUnit conversionFromPatternUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DerivedUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:48'!
convertAmountFromPatternUnit: anAmount 
	
	^ conversionFromPatternUnit value: anAmount.! !

!DerivedUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:49'!
convertAmountToPatternUnit: anAmount 
	
	^ conversionToPatternUnit value: anAmount.! !

!DerivedUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:56'!
initializeWithName: aName
andPatternUnit: thePatternUnit
andConversionToPatternUnit: theConversionToPatternUnit
andConversionFromPatternUnit: theConversionFromPatternUnit

	name := aName.
	patternUnit := thePatternUnit.
	conversionToPatternUnit := theConversionToPatternUnit.
	conversionFromPatternUnit := theConversionFromPatternUnit.! !

!DerivedUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:57'!
initializeWithName: aName
andPatternUnit: aPatternUnit
andFactor: aFactor
	^ self
		initializeWithName: aName
		andPatternUnit: aPatternUnit
		andConversionToPatternUnit: [ :anAmount | anAmount * aFactor ]
		andConversionFromPatternUnit: [ :anAmount | anAmount / aFactor ]! !

!DerivedUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/21/2013 00:13'!
patternUnit
	^ patternUnit.! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/21/2013 00:10'!
celsius
	^ PatternUnit new initializeWithName: 'celsius'.! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:58'!
centimeter
	^ DerivedUnit new initializeWithName: 'centimeter' andPatternUnit: (self meter) andFactor: 1 / 100! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 15:57'!
day
	^ DerivedUnit new initializeWithName: 'day' andPatternUnit: (self second) andFactor: 60*60*24.! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:58'!
decameter
	^ DerivedUnit new initializeWithName: 'decameter' andPatternUnit: (self meter) andFactor: 10! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:58'!
decimeter
	^ DerivedUnit new initializeWithName: 'decimeter' andPatternUnit: (self meter) andFactor: 1/10! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 15:47'!
fahrenheit
	^ DerivedUnit new
		initializeWithName: 'fahrenheit'
		andPatternUnit: (self celsius)
		andConversionToPatternUnit: [ :anFahrenheitAmount | (anFahrenheitAmount - 32) * 5 / 9 ]
		andConversionFromPatternUnit: [ :aCelsiusAmount | aCelsiusAmount * 9 / 5 + 32 ].! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:58'!
hectometer
	^ DerivedUnit new initializeWithName: 'hectometer' andPatternUnit: (self meter) andFactor: 100! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 15:58'!
hour
	^ DerivedUnit new initializeWithName: 'hour' andPatternUnit: (self second) andFactor: 60*60.! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 16:03'!
kelvin
	^ DerivedUnit new
		initializeWithName: 'kelvin'
		andPatternUnit: (self celsius)
		andConversionToPatternUnit: [ :aKelvinAmount | aKelvinAmount + 273 ]
		andConversionFromPatternUnit: [ :aCelsiusAmount | aCelsiusAmount - 273 ].! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:58'!
kilometer
	^ DerivedUnit new initializeWithName: 'kilometer' andPatternUnit: (self meter) andFactor: 1000! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/21/2013 00:02'!
meter
	^ PatternUnit new initializeWithName: 'meter'! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:59'!
millimeter
	^ DerivedUnit new initializeWithName: 'millimeter' andPatternUnit: (self meter) andFactor: 1/1000! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:59'!
minute
	^ DerivedUnit new initializeWithName: 'minute' andPatternUnit: (self second ) andFactor: 60.! !

!MeasureUnit class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/21/2013 00:02'!
second
	^ PatternUnit new initializeWithName: 'second'! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/21/2013 00:16'!
= anotherUnit
	"TODO: deberamos definir/implementar esto de forma que se verifique realmente la igualdad de unidades."
	^ (anotherUnit isKindOf: MeasureUnit)
	  and: [ (name = anotherUnit name) ]! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:48'!
convertAmountFromPatternUnit: anAmount 
	
	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:50'!
convertAmountToPatternUnit: anAmount 
	
	self subclassResponsibility.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'FranciscoWesner 5/21/2013 15:36'!
name
	^ name! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/21/2013 00:12'!
patternUnit
	^ self subclassResponsibility.! !

!MeasureUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/21/2013 00:01'!
printString
	 ^ (self name).! !

MeasureUnit subclass: #NullUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NullUnit class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/22/2013 21:18'!
instance
	
	^ self new initialize! !

!NullUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/22/2013 21:13'!
initialize
	
	name := 'no unit'! !

!NullUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/22/2013 21:15'!
patternUnit
	
	^ self.! !

MeasureUnit subclass: #PatternUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!PatternUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:48'!
convertAmountFromPatternUnit: anAmount 
	
	^ anAmount.! !

!PatternUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/20/2013 23:49'!
convertAmountToPatternUnit: anAmount 
	
	^ anAmount.! !

!PatternUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/21/2013 00:01'!
initializeWithName: aName

	name := aName.! !

!PatternUnit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 5/21/2013 00:14'!
patternUnit 
	^ self.! !

TestCase subclass: #MeasureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'JuanEdi 5/22/2013 20:18'!
canNotConvertMeasurementException
	
	^ Error! !

!MeasureTest methodsFor: 'temperature units' stamp: 'JuanEdi 5/20/2013 20:24'!
celsius
	
	^ MeasureUnit celsius.! !

!MeasureTest methodsFor: 'distance units' stamp: 'JuanEdi 5/20/2013 20:32'!
centimeter
	
	^ MeasureUnit centimeter.! !

!MeasureTest methodsFor: 'time units' stamp: 'FranciscoWesner 5/21/2013 15:53'!
day
	
	^ MeasureUnit day! !

!MeasureTest methodsFor: 'distance units' stamp: 'FranciscoWesner 5/21/2013 15:48'!
decameter
	
	^ MeasureUnit decameter.! !

!MeasureTest methodsFor: 'distance units' stamp: 'FranciscoWesner 5/21/2013 15:48'!
decimeter
	
	^ MeasureUnit decimeter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:35'!
eightCubicMeters

	^self error: 'este metodo debe devolver la medida 8 metros cubicos'! !

!MeasureTest methodsFor: 'temperature units' stamp: 'JuanEdi 5/20/2013 20:37'!
fahrenheit
	
	^ MeasureUnit fahrenheit.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:40'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod

	^self error: 'Implementar la formula de velocidad final: vf = vi + a * t'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:35'!
fourSquaredMeters

	^self error: 'este metodo debe devolver la medida 4 metros cuadrados'! !

!MeasureTest methodsFor: 'distance units' stamp: 'FranciscoWesner 5/21/2013 15:49'!
hectometer
	
	^ MeasureUnit  hectometer.! !

!MeasureTest methodsFor: 'time units' stamp: 'FranciscoWesner 5/21/2013 15:53'!
hour
	
	^ MeasureUnit hour.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'FranciscoWesner 5/21/2013 15:52'!
kelvin
	
	^ MeasureUnit kelvin.! !

!MeasureTest methodsFor: 'distance units' stamp: 'FranciscoWesner 5/21/2013 15:49'!
kilometer
	
	^ MeasureUnit kilometer.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'JuanEdi 5/20/2013 20:20'!
meter

	^ MeasureUnit meter.! !

!MeasureTest methodsFor: 'distance units' stamp: 'FranciscoWesner 5/21/2013 15:49'!
millimeter
	
	^ MeasureUnit millimeter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'FranciscoWesner 5/21/2013 15:50'!
minusOneMeter 
	
	^ Measure withAmount: (-1) measuredIn: (self meter).! !

!MeasureTest methodsFor: 'time units' stamp: 'JuanEdi 5/20/2013 20:34'!
minute
	
	^ MeasureUnit minute.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'FranciscoWesner 5/21/2013 15:51'!
oneCelsius
	
	^ Measure withAmount: 1 measuredIn: (self celsius).! !

!MeasureTest methodsFor: 'distance measures' stamp: 'FranciscoWesner 5/21/2013 15:50'!
oneCentimeter
	
	^ Measure withAmount: 1 measuredIn: (self centimeter).! !

!MeasureTest methodsFor: 'time measures' stamp: 'FranciscoWesner 5/21/2013 15:53'!
oneDay
	
	^ Measure withAmount: 1 measuredIn: (self day).! !

!MeasureTest methodsFor: 'time measures' stamp: 'FranciscoWesner 5/21/2013 15:53'!
oneHour
	
	^ Measure withAmount: 1 measuredIn: (self hour).! !

!MeasureTest methodsFor: 'distance measures' stamp: 'JuanEdi 5/20/2013 20:32'!
oneHundredCentimeters
	
	^ Measure withAmount: 100 measuredIn: (self centimeter).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'efo 5/2/2011 20:56'!
oneHundredTwentyOneMetersPerSecond

	^self error: 'este metodo debe devolver la medida 121 metro/segundo'! !

!MeasureTest methodsFor: 'distance measures' stamp: 'JuanEdi 5/20/2013 21:32'!
oneMeter
	
	^ Measure withAmount: 1 measuredIn: (self meter)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:36'!
oneMeterPerSecond

	^self error: 'este metodo debe devolver la medida 1 metro/segundo'! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanEdi 5/20/2013 20:34'!
oneMinute
	
	^ Measure withAmount: 1 measuredIn: (self minute).! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanEdi 5/20/2013 20:21'!
oneSecond

	^ Measure withAmount: 1 measuredIn: (self second)! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:37'!
oneSquaredMeter

	^self error: 'este metodo debe devolver la medida 1 metro cuadrado'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:36'!
oneSquaredSecond

	^self error: 'este metodo debe devolver la medida 1 segundo cuadrado'! !

!MeasureTest methodsFor: 'time units' stamp: 'JuanEdi 5/20/2013 20:22'!
second
	
	^ MeasureUnit second.! !

!MeasureTest methodsFor: 'time measures' stamp: 'FranciscoWesner 5/21/2013 15:54'!
sixtyMinutes
	
	^ Measure withAmount: 60 measuredIn: (self minute).! !

!MeasureTest methodsFor: 'time measures' stamp: 'FranciscoWesner 5/21/2013 15:54'!
sixtyOneSeconds
	
	^ Measure withAmount: 61 measuredIn: (self second).! !

!MeasureTest methodsFor: 'time measures' stamp: 'JuanEdi 5/20/2013 20:31'!
sixtySeconds
	
	^ Measure withAmount: 60 measuredIn: (self second).! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'JuanEdi 5/21/2013 00:10'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'FranciscoWesner 5/21/2013 15:56'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'JuanEdi 5/22/2013 19:54'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain

	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:52'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self twoMetersBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'JuanEdi 5/20/2013 20:37'!
thirtyTwoFahrenheits
	
	^ Measure withAmount: 32 measuredIn: (self fahrenheit).! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'FranciscoWesner 5/21/2013 15:55'!
twentyFourHours
	
	^ Measure withAmount: 24 measuredIn: (self hour).! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'FranciscoWesner 5/21/2013 15:51'!
twoCelsius
	
	^ Measure withAmount: 2 measuredIn: (self celsius).! !

!MeasureTest methodsFor: 'distance measures' stamp: 'JuanEdi 5/20/2013 20:34'!
twoHundredCentimeters

	^ Measure withAmount: 200 measuredIn: (self centimeter).! !

!MeasureTest methodsFor: 'distance measures' stamp: 'JuanEdi 5/20/2013 20:30'!
twoMeters
	
	^ Measure withAmount: 2 measuredIn: (self meter).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:35'!
twoMetersBySecond

	^self error: 'este metodo debe devolver la medida 2 metros/segundo'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:33'!
twoMetersPerSquaredSecond

	^self error: 'este metodo debe devolver la medida 2 metros/segundoAlCuadrado'! !

!MeasureTest methodsFor: 'compound measures' stamp: 'HernanWilkinson 4/25/2011 17:33'!
twoMetersTimesSecond

	^self error: 'este metodo debe devolver la medida 2 metros*segundo'! !

!MeasureTest methodsFor: 'time measures' stamp: 'FranciscoWesner 5/21/2013 15:55'!
twoSeconds
	
	^ Measure withAmount: 2 measuredIn: (self second).! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'JuanEdi 5/20/2013 20:31'!
zeroCelsius
	
	^ Measure withAmount: 0 measuredIn: (self celsius).! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'FranciscoWesner 5/21/2013 15:51'!
zeroKelvin
	
	^ Measure withAmount: 1 measuredIn: (self kelvin).! !

!MeasureTest methodsFor: 'distance measures' stamp: 'FranciscoWesner 5/21/2013 15:51'!
zeroMeters

	^ Measure withAmount: 0 measuredIn: (self meter).! !

!MeasureTest methodsFor: 'time measures' stamp: 'FranciscoWesner 5/21/2013 15:55'!
zeroSeconds
	
	^ Measure withAmount: 0 measuredIn: (self second).! !
